/*****************************************************************************
  GENERVW.H

  Contains the declaration of the CGeneratorView view class.

  Classes Declared:

    CGeneratorView
  
  Development Team: Robert Duke

  Written by Microsoft Product Support Services, Languages Developer Support
  Copyright (c) 1993 Microsoft Corporation. All rights reserved.
\****************************************************************************/

class CGeneratorView : public CView
{
protected: // create from serialization only
	CGeneratorView();
	DECLARE_DYNCREATE(CGeneratorView)

// Attributes
public:
	CGeneratorDoc* GetDocument();

	// hang on to the return from SetTimer so that we can kill the 
	// timer when the view is closed
	UINT m_uTimerID;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGeneratorView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view

	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGeneratorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGeneratorView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnGenColor();
	afx_msg void OnUpdateGenColor(CCmdUI* pCmdUI);
	afx_msg void OnAnimateColors();
	afx_msg void OnUpdateAnimateColors(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in Genervw.cpp
inline CGeneratorDoc* CGeneratorView::GetDocument()
   { return (CGeneratorDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
